<!DOCTYPE html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Vladimir Remar">
  <title>Proyecto Gandhi Reload</title>
  <style type="text/css">code{white-space: pre;}</style>
  <link rel="stylesheet" href="propi_style.css">
</head>
<body>
<section class="title">
  <h1 class="title">Proyecto Gandhi Reload</h1>
  <footer>
    <span class="author">Vladimir Remar</span> · <span class="date">2018/05/22</span>
  </footer>
</section>
<section id="gandhi-reload" class="slide level1">
<h1>Gandhi Reload</h1>
<p>El objetivo de este proyecto es generar un modelo de acceso a servicios similar a los que brinda el servidor de <strong><em>Gandhi</em></strong> en la escuela pero con cada uno de estos separados en contenedores Docker.</p>
</section>
<section class="slide level1">

<h2 id="tecnologías">Tecnologías:</h2>
<ul class="incremental">
<li><a href="#Servidor-LDAP">LDAP</a></li>
<li><a href="#Servidor-NFS">NFS</a></li>
<li><a href="#Servidor-Kerberos">Kerberos</a></li>
<li><a href="#Servidor-DNS">DNS</a></li>
<li><a href="#Servidor-DHCP">DHCP</a></li>
<li><a href="#Servidor-SSH-Kerberized">SSH-Kerberized</a></li>
<li><a href="#Servidor-FTP-Kerberized">FTP-Kerberized</a></li>
<li><a href="#Servidor-HTTP-Kerberized">HTTP-Kerberized</a></li>
<li><a href="#Servidor-TFTP">TFTP</a></li>
<li><a href="#Servidor-PXE">Servidor PXE</a></li>
<li><a href="#Docker-compose">Docker-Compose</a></li>
</ul>
</section>
<section class="slide level1">

<h2 id="servicios">Servicios</h2>
<p>¿Qué son los servicios básicos?</p>
<p>Son los servicios que permiten a un usuario de nuestra base de datos ldap poder <em>trabajar</em> con normalidad.</p>
<p>¿Qué son los servicios Kerberizados?</p>
<p>Son aquellos servicios, tales como ftp, ssh o http entre otros puedan realizar la autenticacíon via kerberos, es decir cuando un usuario necesita acceder a un servicio de red, el cliente solicita un ticket y dependiendo de cada servicio este lo valida contra la base de datos del servidor de Kerberos.</p>
</section>
<section class="slide level1">

<h2 id="servicios-básicos-de-trabajo"><a href="#Servicios-básicos">Servicios básicos de trabajo</a>:</h2>
<ul class="incremental">
<li>Datos de los usuarios almacenados en un servidor <strong><em>Ldap</em></strong>.</li>
<li>El directorio de ficheros de cada usuario localizado en un servidor <strong><em>NFS</em></strong>.</li>
<li>Autenticación via <strong><em>Kerberos</em></strong>.</li>
<li>Implementación de un servidor de resolución de nombres(<strong><em>DNS</em></strong>) propio de la estructura propia de <em>Gandhi reload</em>.</li>
<li>Para el despliegue de toda nuestra red integraremos nuestro servidor de <strong><em>DHCP</em></strong>.</li>
</ul>
</section>
<section class="slide level1">

<h2 id="servicios-kerberizados"><a href="#Servicios-Kerberizados">Servicios <strong><em>Kerberizados</em></strong></a>:</h2>
<ul class="incremental">
<li>FTP los usuarios podran disponer de sus propios ficheros como los proporcionados por el mismo servidor.</li>
<li>SSH Se permitará el acceso a un sesión remota de los usuarios.</li>
<li>HTTP Acceso a determinda web de nuestro servidor solo para los usuarios autenticados por nuestro servidor de Kerberos.</li>
</ul>
<h2 id="servicios-extras"><a href="#Servicios-extras">Servicios extras</a>:</h2>
<ul class="incremental">
<li>Servidor TFTP.</li>
<li>Servidor PXE.</li>
</ul>
</section>
<section class="slide level1">

<h2 id="atumatización-via-docker-compose">Atumatización via docker-compose</h2>
<p>Todos estos servicios se implementarán en contendores Docker, por ello haremos uso de un fichero <a href="#Docker-compose"><strong><em>docker-compose</em></strong></a> para automatizar tanto la creación como el arranque de nuestros servicios.</p>
</section>
<section class="slide level1">

<h2 id="servidor-ldap">Servidor LDAP</h2>
<ul class="incremental">
<li><p>Entrada Principal</p>
<pre><code>dn: dc=gandhi,dc=reload
dc: gandhi
description: Escola del treball de Barcelona
objectClass: dcObject
objectClass: organization
o: gandhi.reload</code></pre></li>
<li><p>Entrada de la organizacion</p>
<pre><code>dn: ou=usuaris,dc=gandhi,dc=reload
ou: usuaris
description: Container per usuaris del sistema linux
objectclass: organizationalunit</code></pre></li>
</ul>
</section>
<section class="slide level1">

<h2 id="entrada-para-un-usuario">Entrada para un usuario</h2>
<pre><code>    dn: uid=pau,ou=usuaris,dc=gandhi,dc=reload
    objectclass: posixAccount
    objectclass: inetOrgPerson
    cn: Pau Pou
    cn: Pauet Pou
    sn: Pou
    homephone: 555-222-2220
    mail: pau@gandhi.reload
    description: Watch out for this guy
    ou: Profes
    uid: pau
    uidNumber: 5000
    gidNumber: 100
    homeDirectory: /home/users/inf/pau
    userPassword: {SSHA}NDkipesNQqTFDgGJfyraLz/csZAIlk2/</code></pre>
</section>
<section class="slide level1">

<h2 id="servidor-nfs">Servidor NFS</h2>
<p>Dispondremos de un <strong><em>Volumne Docker</em></strong> ubicado en <em>/mnt/dades</em> donde se creará la estructura de directorios para nuestros usuarios, en este caso su <strong><em>home</em></strong>.</p>
<h3 id="entradas">Entradas</h3>
<pre><code>    /mnt/dades/
    |-- 1asix
    |   |-- user01
    |   |-- user02
    |   |-- user03
    |   |-- user04
    |   `-- user05

    drwxr-xr-x. 2 user01  1asix 4096 May 19 12:37 user01
    drwxr-xr-x. 2 user02  1asix 4096 May 19 12:37 user02
    drwxr-xr-x. 2 user03  1asix 4096 May 19 12:37 user03
    drwxr-xr-x. 2 user04  1asix 4096 May 19 12:37 user04
    drwxr-xr-x. 2 user05  1asix 4096 May 19 12:37 user05</code></pre>
</section>
<section class="slide level1">

<h2 id="servidor-kerberos">Servidor Kerberos</h2>
<figure>
<img src="krb.png" alt="kerberos" /><figcaption>kerberos</figcaption>
</figure>
</section>
<section class="slide level1">

<h2 id="servidor-dns">Servidor DNS</h2>
<p>Se creara una zona <strong><em>gandhi.reload</em></strong> y se configura para que resuelva las ips de los servidores(ldap,nfs,kerberos, etc)</p>
<pre><code>            IN  NS     e gandhi.reload.
            IN  A       192.168.2.57
ldap        IN  A       192.168.2.57
krb         IN  A       192.168.2.57
nfs         IN  A       192.168.2.57
sshserver   IN  A       192.168.2.57
ftpserver   IN  A       192.168.2.57
tftpserver  IN  A       192.168.2.57
httpserver  IN  A       192.168.2.57</code></pre>
</section>
<section class="slide level1">

<h2 id="servidor-dhcp">Servidor DHCP</h2>
<p>Para este docker indagaremos en como trabaja las tecnologias de dockers con nuestras interficies de red para ello utilizaremos la <strong><em>network:host</em></strong> que es aquella que nos permite la utilización de todas las interficies de red del <em>host</em> anfitrión que gobierna los contenedores dockers.</p>
<pre><code>docker network ls
NETWORK ID          NAME                DRIVER              SCOPE
d875732dce9c        bridge              bridge              local
8f9f00bc4aa6        gandhireload__net   bridge              local
98a146d8dfb4        host                host                local
49c5f64342c6        none                null                local</code></pre>
</section>
<section class="slide level1">

<h2 id="servidor-de-administración-gadmin">Servidor de Administración Gadmin</h2>
<p>Este Docker hará las funciones de administración de los servidores de ldap, nfs y kerberos.</p>
<p>Desarrollando tareas tales como:</p>
<ul class="incremental">
<li>Añadir usuarios nuevos a nuestra base de datos de ldap.</li>
<li>Gestionar los <strong><em>homes</em></strong> de los usuarios.</li>
<li>Creará entradas de <strong><em>los principals</em></strong> en el servidor de kerberos.</li>
</ul>
</section>
<section class="slide level1">

<h2 id="servicios-kerberizados-1">Servicios Kerberizados</h2>
<figure>
<img src="krbservice.jpg" alt="kerberos2" /><figcaption>kerberos2</figcaption>
</figure>
</section>
<section class="slide level1">

<h2 id="desarrollo">Desarrollo</h2>
<p>Cada uno de estos servicios se configurarán como si de un cliente se tratase, es decir obtendran las configuraciones de nuestros servicios básicos para luego ellos brindar acceso a los mismos de manera remota valiendose de la autenticación via kerberos.</p>
<h2 id="servidor-ssh-kerberized">Servidor SSH Kerberized</h2>
<ul class="incremental">
<li>Acceso a sessiones remota de los usuarios válidos.</li>
</ul>
<h2 id="servidor-ftp-kerberized">Servidor FTP Kerberized</h2>
<ul class="incremental">
<li>Acceso a los ficheros y directorios de los usuarios válidos.</li>
</ul>
<h2 id="servidor-http-kerberized">Servidor HTTP Kerberized</h2>
<ul class="incremental">
<li>Acceso a determinada web solo para usuarios válidos.</li>
</ul>
</section>
<section class="slide level1">

<h2 id="servicios-extras-1">Servicios extras</h2>
<p>Conjuntamente con el servidor de DHCP configuramos el servidor de TFTP y le damos la configuración para nuestro servidor de PXE.</p>
<figure>
<img src="PXE.png" alt="pxe" /><figcaption>pxe</figcaption>
</figure>
</section>
<section class="slide level1">

<h2 id="docker-compose">Docker Compose</h2>
<p>Este mecanismo permite utilizar varias imágenes y comunicarlas, para obtener los requisitos necesarios para hacer funcionar nuestra estructura de gestión.</p>
<pre><code>version: &#39;3&#39;
services:
  #LDAP
  ldap:
    build: 
      context: $PWD/Documentacion/ModoBasico/ServerLdap/
      dockerfile: Dockerfile
    ports:
     - &quot;389:389&quot;
    networks: 
      _net:
        ipv4_address: 172.31.0.2
    container_name: ldap.gandhi.reload
    privileged: true
    hostname: ldap.gandhi.reload</code></pre>
</section>
<section class="slide level1">

<h2 id="conclusiones">Conclusiones</h2>
<p>La idea de llevar determinados servicios a contendores dockers es algo que se debe hacer, si se hace, de manera progresiva para ver que servicios son factibles de ser implementados y cuales no, es decir algunos de estos servicios son facilmente extrapolables, tales como:</p>
<ul class="incremental">
<li>Ldap</li>
<li>Kerberos</li>
<li>Todos los servicios Kerberizados</li>
</ul>
<p>Y otros no tanto, como son:</p>
<ul class="incremental">
<li>Nfs</li>
<li>TFTP</li>
<li>DhCP</li>
</ul>
</section>
<section class="slide level1">

<h2 id="thats-all-folks">That's all folks</h2>
<p>¿Alguna pregunta?</p>
<figure>
<img src="trust.png" alt="admin" /><figcaption>admin</figcaption>
</figure>
</section>
<!-- {{{{ dzslides core
#
#
#     __  __  __       .  __   ___  __
#    |  \  / /__` |    | |  \ |__  /__`
#    |__/ /_ .__/ |___ | |__/ |___ .__/ core :€
#
#
# The following block of code is not supposed to be edited.
# But if you want to change the behavior of these slides,
# feel free to hack it!
#
-->

<div id="progress-bar"></div>

<!-- Default Style -->
<style>
  * { margin: 0; padding: 0; -moz-box-sizing: border-box; -webkit-box-sizing: border-box; box-sizing: border-box; }
  [role="note"] { display: none; }
  body {
    width: 800px; height: 600px;
    margin-left: -400px; margin-top: -300px;
    position: absolute; top: 50%; left: 50%;
    overflow: hidden;
    display: none;
  }
  .view body {
    position: static;
    margin: 0; padding: 0;
    width: 100%; height: 100%;
    display: inline-block;
    overflow: visible; overflow-x: hidden;
    /* undo Dz.onresize */
    transform: none !important;
    -moz-transform: none !important;
    -webkit-transform: none !important;
    -o-transform: none !important;
    -ms-transform: none !important;
  }
  .view head, .view head > title { display: block }
  section {
    position: absolute;
    pointer-events: none;
    width: 100%; height: 100%;
  }
  .view section {
    pointer-events: auto;
    position: static;
    width: 800px; height: 600px;
    margin: -150px -200px;
    float: left;

    transform: scale(.4);
    -moz-transform: scale(.4);
    -webkit-transform: scale(.4);
    -o-transform: scale(.4);
    -ms-transform: scale(.4);
  }
  .view section > * { pointer-events: none; }
  section[aria-selected] { pointer-events: auto; }
  html { overflow: hidden; }
  html.view { overflow: visible; }
  body.loaded { display: block; }
  .incremental {visibility: hidden; }
  .incremental[active] {visibility: visible; }
  #progress-bar{
    bottom: 0;
    position: absolute;
    -moz-transition: width 400ms linear 0s;
    -webkit-transition: width 400ms linear 0s;
    -ms-transition: width 400ms linear 0s;
    transition: width 400ms linear 0s;
  }
  .view #progress-bar {
    display: none;
  }
</style>

<script>
  var Dz = {
    remoteWindows: [],
    idx: -1,
    step: 0,
    html: null,
    slides: null,
    progressBar : null,
    params: {
      autoplay: "1"
    }
  };

  Dz.init = function() {
    document.body.className = "loaded";
    this.slides = Array.prototype.slice.call($$("body > section"));
    this.progressBar = $("#progress-bar");
    this.html = document.body.parentNode;
    this.setupParams();
    this.onhashchange();
    this.setupTouchEvents();
    this.onresize();
    this.setupView();
  }

  Dz.setupParams = function() {
    var p = window.location.search.substr(1).split('&');
    p.forEach(function(e, i, a) {
      var keyVal = e.split('=');
      Dz.params[keyVal[0]] = decodeURIComponent(keyVal[1]);
    });
  // Specific params handling
    if (!+this.params.autoplay)
      $$.forEach($$("video"), function(v){ v.controls = true });
  }

  Dz.onkeydown = function(aEvent) {
    // Don't intercept keyboard shortcuts
    if (aEvent.altKey
      || aEvent.ctrlKey
      || aEvent.metaKey
      || aEvent.shiftKey) {
      return;
    }
    if ( aEvent.keyCode == 37 // left arrow
      || aEvent.keyCode == 38 // up arrow
      || aEvent.keyCode == 33 // page up
    ) {
      aEvent.preventDefault();
      this.back();
    }
    if ( aEvent.keyCode == 39 // right arrow
      || aEvent.keyCode == 40 // down arrow
      || aEvent.keyCode == 34 // page down
    ) {
      aEvent.preventDefault();
      this.forward();
    }
    if (aEvent.keyCode == 35) { // end
      aEvent.preventDefault();
      this.goEnd();
    }
    if (aEvent.keyCode == 36) { // home
      aEvent.preventDefault();
      this.goStart();
    }
    if (aEvent.keyCode == 32) { // space
      aEvent.preventDefault();
      this.toggleContent();
    }
    if (aEvent.keyCode == 70) { // f
      aEvent.preventDefault();
      this.goFullscreen();
    }
    if (aEvent.keyCode == 79) { // o
      aEvent.preventDefault();
      this.toggleView();
    }
  }

  /* Touch Events */

  Dz.setupTouchEvents = function() {
    var orgX, newX;
    var tracking = false;

    var db = document.body;
    db.addEventListener("touchstart", start.bind(this), false);
    db.addEventListener("touchmove", move.bind(this), false);

    function start(aEvent) {
      aEvent.preventDefault();
      tracking = true;
      orgX = aEvent.changedTouches[0].pageX;
    }

    function move(aEvent) {
      if (!tracking) return;
      newX = aEvent.changedTouches[0].pageX;
      if (orgX - newX > 100) {
        tracking = false;
        this.forward();
      } else {
        if (orgX - newX < -100) {
          tracking = false;
          this.back();
        }
      }
    }
  }

  Dz.setupView = function() {
    document.body.addEventListener("click", function ( e ) {
      if (!Dz.html.classList.contains("view")) return;
      if (!e.target || e.target.nodeName != "SECTION") return;

      Dz.html.classList.remove("view");
      Dz.setCursor(Dz.slides.indexOf(e.target) + 1);
    }, false);
  }

  /* Adapt the size of the slides to the window */

  Dz.onresize = function() {
    var db = document.body;
    var sx = db.clientWidth / window.innerWidth;
    var sy = db.clientHeight / window.innerHeight;
    var transform = "scale(" + (1/Math.max(sx, sy)) + ")";

    db.style.MozTransform = transform;
    db.style.WebkitTransform = transform;
    db.style.OTransform = transform;
    db.style.msTransform = transform;
    db.style.transform = transform;
  }


  Dz.getNotes = function(aIdx) {
    var s = $("section:nth-of-type(" + aIdx + ")");
    var d = s.$("[role='note']");
    return d ? d.innerHTML : "";
  }

  Dz.onmessage = function(aEvent) {
    var argv = aEvent.data.split(" "), argc = argv.length;
    argv.forEach(function(e, i, a) { a[i] = decodeURIComponent(e) });
    var win = aEvent.source;
    if (argv[0] === "REGISTER" && argc === 1) {
      this.remoteWindows.push(win);
      this.postMsg(win, "REGISTERED", document.title, this.slides.length);
      this.postMsg(win, "CURSOR", this.idx + "." + this.step);
      return;
    }
    if (argv[0] === "BACK" && argc === 1)
      this.back();
    if (argv[0] === "FORWARD" && argc === 1)
      this.forward();
    if (argv[0] === "START" && argc === 1)
      this.goStart();
    if (argv[0] === "END" && argc === 1)
      this.goEnd();
    if (argv[0] === "TOGGLE_CONTENT" && argc === 1)
      this.toggleContent();
    if (argv[0] === "SET_CURSOR" && argc === 2)
      window.location.hash = "#" + argv[1];
    if (argv[0] === "GET_CURSOR" && argc === 1)
      this.postMsg(win, "CURSOR", this.idx + "." + this.step);
    if (argv[0] === "GET_NOTES" && argc === 1)
      this.postMsg(win, "NOTES", this.getNotes(this.idx));
  }

  Dz.toggleContent = function() {
    // If a Video is present in this new slide, play it.
    // If a Video is present in the previous slide, stop it.
    var s = $("section[aria-selected]");
    if (s) {
      var video = s.$("video");
      if (video) {
        if (video.ended || video.paused) {
          video.play();
        } else {
          video.pause();
        }
      }
    }
  }

  Dz.setCursor = function(aIdx, aStep) {
    // If the user change the slide number in the URL bar, jump
    // to this slide.
    aStep = (aStep != 0 && typeof aStep !== "undefined") ? "." + aStep : ".0";
    window.location.hash = "#" + aIdx + aStep;
  }

  Dz.onhashchange = function() {
    var cursor = window.location.hash.split("#"),
        newidx = 1,
        newstep = 0;
    if (cursor.length == 2) {
      newidx = ~~cursor[1].split(".")[0];
      newstep = ~~cursor[1].split(".")[1];
      if (newstep > Dz.slides[newidx - 1].$$('.incremental > *').length) {
        newstep = 0;
        newidx++;
      }
    }
    this.setProgress(newidx, newstep);
    if (newidx != this.idx) {
      this.setSlide(newidx);
    }
    if (newstep != this.step) {
      this.setIncremental(newstep);
    }
    for (var i = 0; i < this.remoteWindows.length; i++) {
      this.postMsg(this.remoteWindows[i], "CURSOR", this.idx + "." + this.step);
    }
  }

  Dz.back = function() {
    if (this.idx == 1 && this.step == 0) {
      return;
    }
    if (this.step == 0) {
      this.setCursor(this.idx - 1,
                     this.slides[this.idx - 2].$$('.incremental > *').length);
    } else {
      this.setCursor(this.idx, this.step - 1);
    }
  }

  Dz.forward = function() {
    if (this.idx >= this.slides.length &&
        this.step >= this.slides[this.idx - 1].$$('.incremental > *').length) {
        return;
    }
    if (this.step >= this.slides[this.idx - 1].$$('.incremental > *').length) {
      this.setCursor(this.idx + 1, 0);
    } else {
      this.setCursor(this.idx, this.step + 1);
    }
  }

  Dz.goStart = function() {
    this.setCursor(1, 0);
  }

  Dz.goEnd = function() {
    var lastIdx = this.slides.length;
    var lastStep = this.slides[lastIdx - 1].$$('.incremental > *').length;
    this.setCursor(lastIdx, lastStep);
  }

  Dz.toggleView = function() {
    this.html.classList.toggle("view");

    if (this.html.classList.contains("view")) {
      $("section[aria-selected]").scrollIntoView(true);
    }
  }

  Dz.setSlide = function(aIdx) {
    this.idx = aIdx;
    var old = $("section[aria-selected]");
    var next = $("section:nth-of-type("+ this.idx +")");
    if (old) {
      old.removeAttribute("aria-selected");
      var video = old.$("video");
      if (video) {
        video.pause();
      }
    }
    if (next) {
      next.setAttribute("aria-selected", "true");
      if (this.html.classList.contains("view")) {
        next.scrollIntoView();
      }
      var video = next.$("video");
      if (video && !!+this.params.autoplay) {
        video.play();
      }
    } else {
      // That should not happen
      this.idx = -1;
      // console.warn("Slide doesn't exist.");
    }
  }

  Dz.setIncremental = function(aStep) {
    this.step = aStep;
    var old = this.slides[this.idx - 1].$('.incremental > *[aria-selected]');
    if (old) {
      old.removeAttribute('aria-selected');
    }
    var incrementals = $$('.incremental');
    if (this.step <= 0) {
      $$.forEach(incrementals, function(aNode) {
        aNode.removeAttribute('active');
      });
      return;
    }
    var next = this.slides[this.idx - 1].$$('.incremental > *')[this.step - 1];
    if (next) {
      next.setAttribute('aria-selected', true);
      next.parentNode.setAttribute('active', true);
      var found = false;
      $$.forEach(incrementals, function(aNode) {
        if (aNode != next.parentNode)
          if (found)
            aNode.removeAttribute('active');
          else
            aNode.setAttribute('active', true);
        else
          found = true;
      });
    } else {
      setCursor(this.idx, 0);
    }
    return next;
  }

  Dz.goFullscreen = function() {
    var html = $('html'),
        requestFullscreen = html.requestFullscreen || html.requestFullScreen || html.mozRequestFullScreen || html.webkitRequestFullScreen;
    if (requestFullscreen) {
      requestFullscreen.apply(html);
    }
  }
  
  Dz.setProgress = function(aIdx, aStep) {
    var slide = $("section:nth-of-type("+ aIdx +")");
    if (!slide)
      return;
    var steps = slide.$$('.incremental > *').length + 1,
        slideSize = 100 / (this.slides.length - 1),
        stepSize = slideSize / steps;
    this.progressBar.style.width = ((aIdx - 1) * slideSize + aStep * stepSize) + '%';
  }
  
  Dz.postMsg = function(aWin, aMsg) { // [arg0, [arg1...]]
    aMsg = [aMsg];
    for (var i = 2; i < arguments.length; i++)
      aMsg.push(encodeURIComponent(arguments[i]));
    aWin.postMessage(aMsg.join(" "), "*");
  }
  
  function init() {
    Dz.init();
    window.onkeydown = Dz.onkeydown.bind(Dz);
    window.onresize = Dz.onresize.bind(Dz);
    window.onhashchange = Dz.onhashchange.bind(Dz);
    window.onmessage = Dz.onmessage.bind(Dz);
  }

  window.onload = init;
</script>


<script> // Helpers
  if (!Function.prototype.bind) {
    Function.prototype.bind = function (oThis) {

      // closest thing possible to the ECMAScript 5 internal IsCallable
      // function 
      if (typeof this !== "function")
      throw new TypeError(
        "Function.prototype.bind - what is trying to be fBound is not callable"
      );

      var aArgs = Array.prototype.slice.call(arguments, 1),
          fToBind = this,
          fNOP = function () {},
          fBound = function () {
            return fToBind.apply( this instanceof fNOP ? this : oThis || window,
                   aArgs.concat(Array.prototype.slice.call(arguments)));
          };

      fNOP.prototype = this.prototype;
      fBound.prototype = new fNOP();

      return fBound;
    };
  }

  var $ = (HTMLElement.prototype.$ = function(aQuery) {
    return this.querySelector(aQuery);
  }).bind(document);

  var $$ = (HTMLElement.prototype.$$ = function(aQuery) {
    return this.querySelectorAll(aQuery);
  }).bind(document);

  $$.forEach = function(nodeList, fun) {
    Array.prototype.forEach.call(nodeList, fun);
  }

</script>
<!-- vim: set fdm=marker: }}} -->
</body>
</html>
